



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Codeforces Round #349 (Div. 1) A. Reberland Linguistics dp</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Codeforces Round #349 (Div. 1) A. Reberland Linguistics dp</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 19:47:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>题目链接：</h2>
<h4>题目</h4>
<p><strong><a href="http://www.codeforces.com/contest/666/problem/A" rel="external nofollow noreferrer">A. Reberland Linguistics</a></strong><br /><br />
time limit per test：1 second<br /><br />
memory limit per test：256 megabytes</p>
<h4>问题描述</h4>
<p>First-rate specialists graduate from Berland State Institute of Peace and Friendship. You are one of the most talented students in this university. The education is not easy because you need to have fundamental knowledge in different areas, which sometimes are not related to each other.</p>
<p>For example, you should know linguistics very well. You learn a structure of Reberland language as foreign language. In this language words are constructed according to the following rules. First you need to choose the &quot;root&quot; of the word — some string which has more than 4 letters. Then several strings with the length 2 or 3 symbols are appended to this word. The only restriction — it is not allowed to append the same string twice in a row. All these strings are considered to be suffixes of the word (this time we use word &quot;suffix&quot; to describe a morpheme but not the few last characters of the string as you may used to).</p>
<p>Here is one exercise that you have found in your task list. You are given the word s. Find all distinct strings with the length 2 or 3, which can be suffixes of this word according to the word constructing rules in Reberland language.</p>
<p>Two strings are considered distinct if they have different length or there is a position in which corresponding characters do not match.</p>
<p>Let's look at the example: the word abacabaca is given. This word can be obtained in the following ways: , where the root of the word is overlined, and suffixes are marked by &quot;corners&quot;. Thus, the set of possible suffixes for this word is {aca, ba, ca}.</p>
<h4>输入</h4>
<p>The only line contains a string s (5 ≤ |s| ≤ 104) consisting of lowercase English letters.</p>
<h4>输出</h4>
<p>On the first line print integer k — a number of distinct possible suffixes. On the next k lines print suffixes.</p>
<p>Print suffixes in lexicographical (alphabetical) order.</p>
<h4>样例</h4>
<p><strong>input</strong><br /><br />
abacabaca</p>
<p><strong>output</strong><br /><br />
3<br /><br />
aca<br /><br />
ba<br /><br />
ca</p>
<h2>题意</h2>
<p>英语渣orz不知道“twice in a row”是指连续两个的意思。。</p>
<p>先把串的开头5个去掉，把剩下的分割为长度为2,3的若干个子串，并且任何相邻的子串不能相同，问最后能形成的所有合法的不同子串。</p>
<h2>题解</h2>
<p>dp[i][0]表示以i结尾的长度为2的子串是否能分割出来。<br /><br />
dp[i][1]表示以i结尾的长度为3的子串是否能分割出来。<br /><br />
则有状态转移：<br /><br />
dp[i][0]=dp[i-2][1]||dp[i-2][0]&amp;&amp;(str[i]!=str[i-2]||str[i-1]!=str[i-3])<br /><br />
dp[i][1]类似上面的转移。</p>
<h2>代码</h2>
<pre class="prettyprint linenums"><code>#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;string&gt;<br />
using namespace std;

const int maxn = 1e4 + 10;

string str;<br />
int n;<br />
bool dp[maxn][2];

int main() {<br />
	cin &gt;&gt; str;<br />
	n = str.length();<br />
	reverse(str.begin(),str.end());<br />
	memset(dp, 0, sizeof(dp));<br />
	if(n&gt;=7) dp[1][0] = 1;<br />
	if (n &gt;= 8) dp[2][1] = 1;<br />
	for (int i = 3; i &lt; n - 5; i++) {<br />
		if (dp[i - 2][1]) {<br />
			dp[i][0] = 1;<br />
		}<br />
		if (dp[i - 2][0] &amp;&amp; !(str[i] == str[i - 2] &amp;&amp; str[i - 1] == str[i - 3])) {<br />
			dp[i][0] = 1;<br />
		}<br />
		if (dp[i - 3][0]) {<br />
			dp[i][1] = 1;<br />
		}<br />
		if (dp[i - 3][1] &amp;&amp; !(str[i] == str[i - 3] &amp;&amp; str[i - 1] == str[i - 4] &amp;&amp; str[i - 2] == str[i - 5])) {<br />
			dp[i][1] = 1;<br />
		}<br />
	}<br />
	vector&lt;string&gt; ans;<br />
	string s;<br />
	for (int i = 0; i &lt; n - 5; i++) {<br />
		if (dp[i][0]) {<br />
			s = &quot;&quot;; s += str[i]; s += str[i - 1];<br />
			ans.push_back(s);<br />
		}<br />
		if (dp[i][1]) {<br />
			s = &quot;&quot;; s += str[i]; s += str[i - 1]; s += str[i - 2];<br />
			ans.push_back(s);<br />
		}<br />
	}<br />
	sort(ans.begin(), ans.end());<br />
	ans.erase(unique(ans.begin(), ans.end()),ans.end());<br />
	cout &lt;&lt; ans.size() &lt;&lt; endl;<br />
	for (int i = 0; i &lt; ans.size(); i++) {<br />
		cout &lt;&lt; ans[i] &lt;&lt; endl;<br />
	}<br />
	return 0;<br />
}</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyo73x8.html">Openjudge 1&period;13-40 提取数字串按数值排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ke3d58.html">傻逼Eclipse笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/4954vw0q.html">mysqld参数配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyprwjq.html">php如何将数组保存为文件的方法？ 三个方法让你快速把数组保存成为文件存储</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okjxnl9.html">清除PDF里的元数据和机密信息的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7my1g1q.html">Bellman&lowbar;ford POJ 3259 Wormholes</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x415w9.html">mongodb创建副本集命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1y1wdq.html">mysql&lowbar;自动备份</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojg2j5q.html">Memcached和Redis简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljvy1x9.html">新入门的小白，整理一下特别简单实用的div&plus;css兼容性的问题。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy10dmgq.html">Bash &colon; test 命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo5olxq.html">python3 使用代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd1rly9.html">Kindle：自动追更之Calibre2脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvmr428.html">Codeforces Round &num;554 &lpar;Div&period; 2&rpar;   C&period; Neko does Maths  &lpar;简单推导&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4426x9.html">【翻译】JavaScript中5个值得被广泛使用的数组方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1o5p1q.html">item 4&colon; 知道怎么去看推导的类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdje4lxq.html">如何写django中form的测试用例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpe5o09.html">第三方包jintellitype实现Java设置全局热键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv4xngq.html">linux如何删除行首的空格</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kokm2rq.html">win10 安装oracle 11gR2&lowbar;database出现universal Installer后闪退就没反应的解决方案</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k15lj39.html">Jquery实现循环删除Reaper某一行</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjxypy9.html">放弃SCOPE&lowbar;Identity&comma;使用OUTPUT代替</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd033r8.html">本地wamp的Internal Server Error错误解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxner308.html">jquery实现多行文字图片滚动效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm5dk69.html">JqueryPagination 分页插件使用说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1jpwn9.html">ReactiveCocoa比较区分replay&comma; replayLast和replayLazily</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xjkwz8.html">Mongo客户端MongoVUE的基本使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn15xwx8.html">模板template</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd0oge8.html">&lbrack;大牛翻译系列&rsqb;Hadoop（14）MapReduce 性能调优：减小数据倾斜的性能损失</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok57259.html">Nginx启动、停止与平滑重启</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
